import { Component, ViewChild<% if(!!viewEncapsulation) { %>, ViewEncapsulation<% }%><% if(changeDetection !== 'Default') { %>, ChangeDetectionStrategy<% }%> } from '@angular/core';
import { FormBuilder, Validators } from '@angular/forms';

@Component({
  selector: '<%= selector %>',
  <% if(inlineTemplate) { %>
  template: `
<%= resolvedFiles.template %>
  `,<% } else { %>
  templateUrl: './<%= dasherize(name) %>.component.html',<% } if(inlineStyle) { %>
  styles: [
    `
<%= resolvedFiles.stylesheet %>
    `
  ],<% } else { %>
  styleUrls: ['./<%= dasherize(name) %>.component.<%= styleext %>'],<% } %><% if(!!viewEncapsulation) { %>
  encapsulation: ViewEncapsulation.<%= viewEncapsulation %><% } if (changeDetection !== 'Default') { %>,
  changeDetection: ChangeDetectionStrategy.<%= changeDetection %><% } %>
})
export class <%= classify(name) %>Component {
  addressForm = this.fb.group({
    company: null,
    firstName: [null, Validators.required],
    lastName: [null, Validators.required],
    address: [null, Validators.required],
    address2: null,
    city: [null, Validators.required],
    state: [null, Validators.required],
    postalCode: [null, Validators.required, Validators.minLength(5), Validators.maxLength(5)],
    shipping: ['free', Validators.required]
  });

  hasUnitNumber = false;

  states = [
    {name:'Alabama', abbreviation:'AL'},
    {name:'Alaska', abbreviation:'AK'},
    {name:'American Samoa', abbreviation:'AS'},
    {name:'Arizona', abbreviation:'AZ'},
    {name:'Arkansas', abbreviation:'AR'},
    {name:'California', abbreviation:'CA'},
    {name:'Colorado', abbreviation:'CO'},
    {name:'Connecticut', abbreviation:'CT'},
    {name:'Delaware', abbreviation:'DE'},
    {name:'District Of Columbia', abbreviation:'DC'},
    {name:'Federated States Of Micronesia', abbreviation:'FM'},
    {name:'Florida', abbreviation:'FL'},
    {name:'Georgia', abbreviation:'GA'},
    {name:'Guam', abbreviation:'GU'},
    {name:'Hawaii', abbreviation:'HI'},
    {name:'Idaho', abbreviation:'ID'},
    {name:'Illinois', abbreviation:'IL'},
    {name:'Indiana', abbreviation:'IN'},
    {name:'Iowa', abbreviation:'IA'},
    {name:'Kansas', abbreviation:'KS'},
    {name:'Kentucky', abbreviation:'KY'},
    {name:'Louisiana', abbreviation:'LA'},
    {name:'Maine', abbreviation:'ME'},
    {name:'Marshall Islands', abbreviation:'MH'},
    {name:'Maryland', abbreviation:'MD'},
    {name:'Massachusetts', abbreviation:'MA'},
    {name:'Michigan', abbreviation:'MI'},
    {name:'Minnesota', abbreviation:'MN'},
    {name:'Mississippi', abbreviation:'MS'},
    {name:'Missouri', abbreviation:'MO'},
    {name:'Montana', abbreviation:'MT'},
    {name:'Nebraska', abbreviation:'NE'},
    {name:'Nevada', abbreviation:'NV'},
    {name:'New Hampshire', abbreviation:'NH'},
    {name:'New Jersey', abbreviation:'NJ'},
    {name:'New Mexico', abbreviation:'NM'},
    {name:'New York', abbreviation:'NY'},
    {name:'North Carolina', abbreviation:'NC'},
    {name:'North Dakota', abbreviation:'ND'},
    {name:'Northern Mariana Islands', abbreviation:'MP'},
    {name:'Ohio', abbreviation:'OH'},
    {name:'Oklahoma', abbreviation:'OK'},
    {name:'Oregon', abbreviation:'OR'},
    {name:'Palau', abbreviation:'PW'},
    {name:'Pennsylvania', abbreviation:'PA'},
    {name:'Puerto Rico', abbreviation:'PR'},
    {name:'Rhode Island', abbreviation:'RI'},
    {name:'South Carolina', abbreviation:'SC'},
    {name:'South Dakota', abbreviation:'SD'},
    {name:'Tennessee', abbreviation:'TN'},
    {name:'Texas', abbreviation:'TX'},
    {name:'Utah', abbreviation:'UT'},
    {name:'Vermont', abbreviation:'VT'},
    {name:'Virgin Islands', abbreviation:'VI'},
    {name:'Virginia', abbreviation:'VA'},
    {name:'Washington', abbreviation:'WA'},
    {name:'West Virginia', abbreviation:'WV'},
    {name:'Wisconsin', abbreviation:'WI'},
    {name:'Wyoming', abbreviation:'WY'}
  ];

  constructor(private fb: FormBuilder) {}

  onSubmit() {
    alert('Thanks!');
  }
}
