/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@angular/core"),require("@angular/cdk/bidi"),require("@angular/cdk/coercion"),require("rxjs"),require("@angular/cdk/platform"),require("@angular/platform-browser"),require("@angular/platform-browser/animations"),require("@angular/cdk/keycodes"),require("@angular/common")):"function"==typeof define&&define.amd?define("@angular/material/core",["exports","@angular/core","@angular/cdk/bidi","@angular/cdk/coercion","rxjs","@angular/cdk/platform","@angular/platform-browser","@angular/platform-browser/animations","@angular/cdk/keycodes","@angular/common"],e):e((t.ng=t.ng||{},t.ng.material=t.ng.material||{},t.ng.material.core={}),t.ng.core,t.ng.cdk.bidi,t.ng.cdk.coercion,t.rxjs,t.ng.cdk.platform,t.ng.platformBrowser,t.ng.platformBrowser.animations,t.ng.cdk.keycodes,t.ng.common)}(this,function(t,e,n,i,r,o,a,s,c,l){"use strict";function p(t,e){function n(){this.constructor=t}w(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}function u(){return!0}function d(t){return function(t){function e(){for(var e=[],n=0;n<arguments.length;n++)e[n]=arguments[n];var i=t.apply(this,e)||this;return i._disabled=!1,i}return p(e,t),Object.defineProperty(e.prototype,"disabled",{get:function(){return this._disabled},set:function(t){this._disabled=i.coerceBooleanProperty(t)},enumerable:!0,configurable:!0}),e}(t)}function h(t,e){return function(t){function n(){for(var n=[],i=0;i<arguments.length;i++)n[i]=arguments[i];var r=t.apply(this,n)||this;return r.color=e,r}return p(n,t),Object.defineProperty(n.prototype,"color",{get:function(){return this._color},set:function(t){var n=t||e;n!==this._color&&(this._color&&this._elementRef.nativeElement.classList.remove("mat-"+this._color),n&&this._elementRef.nativeElement.classList.add("mat-"+n),this._color=n)},enumerable:!0,configurable:!0}),n}(t)}function m(t){return function(t){function e(){for(var e=[],n=0;n<arguments.length;n++)e[n]=arguments[n];var i=t.apply(this,e)||this;return i._disableRipple=!1,i}return p(e,t),Object.defineProperty(e.prototype,"disableRipple",{get:function(){return this._disableRipple},set:function(t){this._disableRipple=i.coerceBooleanProperty(t)},enumerable:!0,configurable:!0}),e}(t)}function f(t,e){return void 0===e&&(e=0),function(t){function n(){for(var n=[],i=0;i<arguments.length;i++)n[i]=arguments[i];var r=t.apply(this,n)||this;return r._tabIndex=e,r}return p(n,t),Object.defineProperty(n.prototype,"tabIndex",{get:function(){return this.disabled?-1:this._tabIndex},set:function(t){this._tabIndex=null!=t?t:e},enumerable:!0,configurable:!0}),n}(t)}function g(t){return function(t){function e(){for(var e=[],n=0;n<arguments.length;n++)e[n]=arguments[n];var i=t.apply(this,e)||this;return i.errorState=!1,i.stateChanges=new r.Subject,i}return p(e,t),e.prototype.updateErrorState=function(){var t=this.errorState,e=this._parentFormGroup||this._parentForm,n=this.errorStateMatcher||this._defaultErrorStateMatcher,i=this.ngControl?this.ngControl.control:null,r=n.isErrorState(i,e);r!==t&&(this.errorState=r,this.stateChanges.next())},e}(t)}function _(t){return function(t){function e(){for(var e=[],n=0;n<arguments.length;n++)e[n]=arguments[n];var i=t.apply(this,e)||this;return i._isInitialized=!1,i._pendingSubscribers=[],i.initialized=new r.Observable(function(t){i._isInitialized?i._notifySubscriber(t):i._pendingSubscribers.push(t)}),i}return p(e,t),e.prototype._markInitialized=function(){if(this._isInitialized)throw Error("This directive has already been marked as initialized and should not be called twice.");this._isInitialized=!0,this._pendingSubscribers.forEach(this._notifySubscriber),this._pendingSubscribers=null},e.prototype._notifySubscriber=function(t){t.next(),t.complete()},e}(t)}function y(){return e.inject(e.LOCALE_ID)}function b(t,e){for(var n=Array(t),i=0;i<t;i++)n[i]=e(i);return n}function v(t){window.getComputedStyle(t).getPropertyValue("opacity")}function D(t,e,n){var i=Math.max(Math.abs(t-n.left),Math.abs(t-n.right)),r=Math.max(Math.abs(e-n.top),Math.abs(e-n.bottom));return Math.sqrt(i*i+r*r)}function E(t,e,n){if(n.length){for(var i=e.toArray(),r=n.toArray(),o=0,a=0;a<t+1;a++)i[a].group&&i[a].group===r[o]&&o++;return o}return 0}function I(t,e,n,i){var r=t*e;return r<n?r:r+e>n+i?Math.max(0,r-i+e):n}var w=function(t,e){return(w=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(t,e)},O=function(){return O=Object.assign||function(t){for(var e,n=1,i=arguments.length;n<i;n++){e=arguments[n];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&(t[r]=e[r])}return t},O.apply(this,arguments)},C=function(){function t(){}return t.STANDARD_CURVE="cubic-bezier(0.4,0.0,0.2,1)",t.DECELERATION_CURVE="cubic-bezier(0.0,0.0,0.2,1)",t.ACCELERATION_CURVE="cubic-bezier(0.4,0.0,1,1)",t.SHARP_CURVE="cubic-bezier(0.4,0.0,0.6,1)",t}(),x=function(){function t(){}return t.COMPLEX="375ms",t.ENTERING="225ms",t.EXITING="195ms",t}(),M=new e.InjectionToken("mat-sanity-checks",{providedIn:"root",factory:u}),T=function(){function t(t){this._sanityChecksEnabled=t,this._hasDoneGlobalChecks=!1,this._hasCheckedHammer=!1,this._document="object"==typeof document&&document?document:null,this._window="object"==typeof window&&window?window:null,this._areChecksEnabled()&&!this._hasDoneGlobalChecks&&(this._checkDoctypeIsDefined(),this._checkThemeIsPresent(),this._hasDoneGlobalChecks=!0)}return t.prototype._areChecksEnabled=function(){return this._sanityChecksEnabled&&e.isDevMode()&&!this._isTestEnv()},t.prototype._isTestEnv=function(){return this._window&&(this._window.__karma__||this._window.jasmine)},t.prototype._checkDoctypeIsDefined=function(){this._document&&!this._document.doctype&&console.warn("Current document does not have a doctype. This may cause some Angular Material components not to behave as expected.")},t.prototype._checkThemeIsPresent=function(){if(this._document&&this._document.body&&"function"==typeof getComputedStyle){var t=this._document.createElement("div");t.classList.add("mat-theme-loaded-marker"),this._document.body.appendChild(t);var e=getComputedStyle(t);e&&"none"!==e.display&&console.warn("Could not find Angular Material core theme. Most Material components may not work as expected. For more info refer to the theming guide: https://material.angular.io/guide/theming"),this._document.body.removeChild(t)}},t.prototype._checkHammerIsAvailable=function(){!this._hasCheckedHammer&&this._window&&(this._areChecksEnabled()&&!this._window.Hammer&&console.warn("Could not find HammerJS. Certain Angular Material components may not work correctly."),this._hasCheckedHammer=!0)},t.decorators=[{type:e.NgModule,args:[{imports:[n.BidiModule],exports:[n.BidiModule]}]}],t.ctorParameters=function(){return[{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[M]}]}]},t}(),k=new e.InjectionToken("MAT_DATE_LOCALE",{providedIn:"root",factory:y}),R={provide:k,useExisting:e.LOCALE_ID},A=function(){function t(){this._localeChanges=new r.Subject}return Object.defineProperty(t.prototype,"localeChanges",{get:function(){return this._localeChanges},enumerable:!0,configurable:!0}),t.prototype.deserialize=function(t){return null==t||this.isDateInstance(t)&&this.isValid(t)?t:this.invalid()},t.prototype.setLocale=function(t){this.locale=t,this._localeChanges.next()},t.prototype.compareDate=function(t,e){return this.getYear(t)-this.getYear(e)||this.getMonth(t)-this.getMonth(e)||this.getDate(t)-this.getDate(e)},t.prototype.sameDate=function(t,e){if(t&&e){var n=this.isValid(t),i=this.isValid(e);return n&&i?!this.compareDate(t,e):n==i}return t==e},t.prototype.clampDate=function(t,e,n){return e&&this.compareDate(t,e)<0?e:n&&this.compareDate(t,n)>0?n:t},t}(),S=new e.InjectionToken("mat-date-formats"),N="undefined"!=typeof Intl,P={long:["January","February","March","April","May","June","July","August","September","October","November","December"],short:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],narrow:["J","F","M","A","M","J","J","A","S","O","N","D"]},L=function(t){return String(t+1)},j=b(31,L),F={long:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],short:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],narrow:["S","M","T","W","T","F","S"]},V=/^\d{4}-\d{2}-\d{2}(?:T\d{2}:\d{2}:\d{2}(?:\.\d+)?(?:Z|(?:(?:\+|-)\d{2}:\d{2}))?)?$/,z=function(t){function n(e,n){var i=t.call(this)||this;return i.useUtcForDisplay=!0,t.prototype.setLocale.call(i,e),i.useUtcForDisplay=!n.TRIDENT,i._clampDate=n.TRIDENT||n.EDGE,i}return p(n,t),n.prototype.getYear=function(t){return t.getFullYear()},n.prototype.getMonth=function(t){return t.getMonth()},n.prototype.getDate=function(t){return t.getDate()},n.prototype.getDayOfWeek=function(t){return t.getDay()},n.prototype.getMonthNames=function(t){var e=this;if(N){var n=new Intl.DateTimeFormat(this.locale,{month:t,timeZone:"utc"});return b(12,function(t){return e._stripDirectionalityCharacters(e._format(n,new Date(2017,t,1)))})}return P[t]},n.prototype.getDateNames=function(){var t=this;if(N){var e=new Intl.DateTimeFormat(this.locale,{day:"numeric",timeZone:"utc"});return b(31,function(n){return t._stripDirectionalityCharacters(t._format(e,new Date(2017,0,n+1)))})}return j},n.prototype.getDayOfWeekNames=function(t){var e=this;if(N){var n=new Intl.DateTimeFormat(this.locale,{weekday:t,timeZone:"utc"});return b(7,function(t){return e._stripDirectionalityCharacters(e._format(n,new Date(2017,0,t+1)))})}return F[t]},n.prototype.getYearName=function(t){if(N){var e=new Intl.DateTimeFormat(this.locale,{year:"numeric",timeZone:"utc"});return this._stripDirectionalityCharacters(this._format(e,t))}return String(this.getYear(t))},n.prototype.getFirstDayOfWeek=function(){return 0},n.prototype.getNumDaysInMonth=function(t){return this.getDate(this._createDateWithOverflow(this.getYear(t),this.getMonth(t)+1,0))},n.prototype.clone=function(t){return this.createDate(this.getYear(t),this.getMonth(t),this.getDate(t))},n.prototype.createDate=function(t,e,n){if(e<0||e>11)throw Error('Invalid month index "'+e+'". Month index has to be between 0 and 11.');if(n<1)throw Error('Invalid date "'+n+'". Date has to be greater than 0.');var i=this._createDateWithOverflow(t,e,n);if(i.getMonth()!=e)throw Error('Invalid date "'+n+'" for month with index "'+e+'".');return i},n.prototype.today=function(){return new Date},n.prototype.parse=function(t){return"number"==typeof t?new Date(t):t?new Date(Date.parse(t)):null},n.prototype.format=function(t,e){if(!this.isValid(t))throw Error("NativeDateAdapter: Cannot format invalid date.");if(N){this._clampDate&&(t.getFullYear()<1||t.getFullYear()>9999)&&(t=this.clone(t),t.setFullYear(Math.max(1,Math.min(9999,t.getFullYear())))),e=O({},e,{timeZone:"utc"});var n=new Intl.DateTimeFormat(this.locale,e);return this._stripDirectionalityCharacters(this._format(n,t))}return this._stripDirectionalityCharacters(t.toDateString())},n.prototype.addCalendarYears=function(t,e){return this.addCalendarMonths(t,12*e)},n.prototype.addCalendarMonths=function(t,e){var n=this._createDateWithOverflow(this.getYear(t),this.getMonth(t)+e,this.getDate(t));return this.getMonth(n)!=((this.getMonth(t)+e)%12+12)%12&&(n=this._createDateWithOverflow(this.getYear(n),this.getMonth(n),0)),n},n.prototype.addCalendarDays=function(t,e){return this._createDateWithOverflow(this.getYear(t),this.getMonth(t),this.getDate(t)+e)},n.prototype.toIso8601=function(t){return[t.getUTCFullYear(),this._2digit(t.getUTCMonth()+1),this._2digit(t.getUTCDate())].join("-")},n.prototype.deserialize=function(e){if("string"==typeof e){if(!e)return null;if(V.test(e)){var n=new Date(e);if(this.isValid(n))return n}}return t.prototype.deserialize.call(this,e)},n.prototype.isDateInstance=function(t){return t instanceof Date},n.prototype.isValid=function(t){return!isNaN(t.getTime())},n.prototype.invalid=function(){return new Date(NaN)},n.prototype._createDateWithOverflow=function(t,e,n){var i=new Date(t,e,n);return t>=0&&t<100&&i.setFullYear(this.getYear(i)-1900),i},n.prototype._2digit=function(t){return("00"+t).slice(-2)},n.prototype._stripDirectionalityCharacters=function(t){return t.replace(/[\u200e\u200f]/g,"")},n.prototype._format=function(t,e){var n=new Date(Date.UTC(e.getFullYear(),e.getMonth(),e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds(),e.getMilliseconds()));return t.format(n)},n.decorators=[{type:e.Injectable}],n.ctorParameters=function(){return[{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[k]}]},{type:o.Platform}]},n}(A),Y={parse:{dateInput:null},display:{dateInput:{year:"numeric",month:"numeric",day:"numeric"},monthYearLabel:{year:"numeric",month:"short"},dateA11yLabel:{year:"numeric",month:"long",day:"numeric"},monthYearA11yLabel:{year:"numeric",month:"long"}}},U=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{imports:[o.PlatformModule],providers:[{provide:A,useClass:z}]}]}],t}(),H=Y,G=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{imports:[U],providers:[{provide:S,useValue:H}]}]}],t}(),B=function(){function t(){}return t.prototype.isErrorState=function(t,e){return!!(t&&t.invalid&&(t.dirty||e&&e.submitted))},t.decorators=[{type:e.Injectable}],t}(),W=function(){function t(){}return t.prototype.isErrorState=function(t,e){return!!(t&&t.invalid&&(t.touched||e&&e.submitted))},t.decorators=[{type:e.Injectable,args:[{providedIn:"root"}]}],t.ngInjectableDef=e.defineInjectable({factory:function(){return new t},token:t,providedIn:"root"}),t}(),J=new e.InjectionToken("MAT_HAMMER_OPTIONS"),Z=["longpress","slide","slidestart","slideend","slideright","slideleft"],q=function(){},X=function(){},K={on:q,off:X},$=function(t){function n(e,n){var i=t.call(this)||this;return i._hammerOptions=e,i.events=Z,n&&n._checkHammerIsAvailable(),i}return p(n,t),n.prototype.buildHammer=function(t){var e="undefined"!=typeof window?window.Hammer:null;if(!e)return K;var n=new e(t,this._hammerOptions||void 0),i=new e.Pan,r=new e.Swipe,o=new e.Press,a=this._createRecognizer(i,{event:"slide",threshold:0},r),s=this._createRecognizer(o,{event:"longpress",time:500});return i.recognizeWith(r),n.add([r,o,i,a,s]),n},n.prototype._createRecognizer=function(t,e){for(var n=[],i=2;i<arguments.length;i++)n[i-2]=arguments[i];var r=new t.constructor(e);return n.push(t),n.forEach(function(t){return r.recognizeWith(t)}),r},n.decorators=[{type:e.Injectable}],n.ctorParameters=function(){return[{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[J]}]},{type:T,decorators:[{type:e.Optional}]}]},n}(a.HammerGestureConfig),Q=function(){function t(){}return t.decorators=[{type:e.Directive,args:[{selector:"[mat-line], [matLine]",host:{class:"mat-line"}}]}],t}(),tt=function(){function t(t,e){var n=this;this._lines=t,this._element=e,this._setLineClass(this._lines.length),this._lines.changes.subscribe(function(){n._setLineClass(n._lines.length)})}return t.prototype._setLineClass=function(t){this._resetClasses(),2===t||3===t?this._setClass("mat-"+t+"-line",!0):t>3&&this._setClass("mat-multi-line",!0)},t.prototype._resetClasses=function(){this._setClass("mat-2-line",!1),this._setClass("mat-3-line",!1),this._setClass("mat-multi-line",!1)},t.prototype._setClass=function(t,e){e?this._element.nativeElement.classList.add(t):this._element.nativeElement.classList.remove(t)},t}(),et=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{imports:[T],exports:[Q,T],declarations:[Q]}]}],t}(),nt={FADING_IN:0,VISIBLE:1,FADING_OUT:2,HIDDEN:3};nt[nt.FADING_IN]="FADING_IN",nt[nt.VISIBLE]="VISIBLE",nt[nt.FADING_OUT]="FADING_OUT",nt[nt.HIDDEN]="HIDDEN";var it=function(){function t(t,e,n){this._renderer=t,this.element=e,this.config=n,this.state=nt.HIDDEN}return t.prototype.fadeOut=function(){this._renderer.fadeOutRipple(this)},t}(),rt={enterDuration:450,exitDuration:400},ot=800,at=function(){function t(t,e,n,i){var r=this;this._target=t,this._ngZone=e,this._isPointerDown=!1,this._triggerEvents=new Map,this._activeRipples=new Set,this._eventOptions=!!o.supportsPassiveEventListeners()&&{passive:!0},this.onMousedown=function(t){var e=r._lastTouchStartEvent&&Date.now()<r._lastTouchStartEvent+ot;r._target.rippleDisabled||e||(r._isPointerDown=!0,r.fadeInRipple(t.clientX,t.clientY,r._target.rippleConfig))},this.onTouchStart=function(t){r._target.rippleDisabled||(r._lastTouchStartEvent=Date.now(),r._isPointerDown=!0,r.fadeInRipple(t.touches[0].clientX,t.touches[0].clientY,r._target.rippleConfig))},this.onPointerUp=function(){r._isPointerDown&&(r._isPointerDown=!1,r._activeRipples.forEach(function(t){var e=t.state===nt.VISIBLE||t.config.terminateOnPointerUp&&t.state===nt.FADING_IN;!t.config.persistent&&e&&t.fadeOut()}))},i.isBrowser&&(this._containerElement=n.nativeElement,this._triggerEvents.set("mousedown",this.onMousedown),this._triggerEvents.set("mouseup",this.onPointerUp),this._triggerEvents.set("mouseleave",this.onPointerUp),this._triggerEvents.set("touchstart",this.onTouchStart),this._triggerEvents.set("touchend",this.onPointerUp))}return t.prototype.fadeInRipple=function(t,e,n){var i=this;void 0===n&&(n={});var r=this._containerRect=this._containerRect||this._containerElement.getBoundingClientRect(),o=O({},rt,n.animation);n.centered&&(t=r.left+r.width/2,e=r.top+r.height/2);var a=n.radius||D(t,e,r),s=t-r.left,c=e-r.top,l=o.enterDuration/(n.speedFactor||1),p=document.createElement("div");p.classList.add("mat-ripple-element"),p.style.left=s-a+"px",p.style.top=c-a+"px",p.style.height=2*a+"px",p.style.width=2*a+"px",p.style.backgroundColor=n.color||null,p.style.transitionDuration=l+"ms",this._containerElement.appendChild(p),v(p),p.style.transform="scale(1)";var u=new it(this,p,n);return u.state=nt.FADING_IN,this._activeRipples.add(u),n.persistent||(this._mostRecentTransientRipple=u),this.runTimeoutOutsideZone(function(){var t=u===i._mostRecentTransientRipple;u.state=nt.VISIBLE,n.persistent||t&&i._isPointerDown||u.fadeOut()},l),u},t.prototype.fadeOutRipple=function(t){var e=this._activeRipples.delete(t);if(t===this._mostRecentTransientRipple&&(this._mostRecentTransientRipple=null),this._activeRipples.size||(this._containerRect=null),e){var n=t.element,i=O({},rt,t.config.animation);n.style.transitionDuration=i.exitDuration+"ms",n.style.opacity="0",t.state=nt.FADING_OUT,this.runTimeoutOutsideZone(function(){t.state=nt.HIDDEN,n.parentNode.removeChild(n)},i.exitDuration)}},t.prototype.fadeOutAll=function(){this._activeRipples.forEach(function(t){return t.fadeOut()})},t.prototype.setupTriggerEvents=function(t){var e=this;t&&t!==this._triggerElement&&(this._removeTriggerEvents(),this._ngZone.runOutsideAngular(function(){e._triggerEvents.forEach(function(n,i){return t.addEventListener(i,n,e._eventOptions)})}),this._triggerElement=t)},t.prototype.runTimeoutOutsideZone=function(t,e){void 0===e&&(e=0),this._ngZone.runOutsideAngular(function(){return setTimeout(t,e)})},t.prototype._removeTriggerEvents=function(){var t=this;this._triggerElement&&this._triggerEvents.forEach(function(e,n){t._triggerElement.removeEventListener(n,e,t._eventOptions)})},t}(),st=new e.InjectionToken("mat-ripple-global-options"),ct=function(){function t(t,e,n,i,r){this._elementRef=t,this.radius=0,this.speedFactor=1,this._disabled=!1,this._isInitialized=!1,this._globalOptions=i||{},this._rippleRenderer=new at(this,e,t,n),"NoopAnimations"===r&&(this._globalOptions.animation={enterDuration:0,exitDuration:0})}return Object.defineProperty(t.prototype,"disabled",{get:function(){return this._disabled},set:function(t){this._disabled=t,this._setupTriggerEventsIfEnabled()},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"trigger",{get:function(){return this._trigger||this._elementRef.nativeElement},set:function(t){this._trigger=t,this._setupTriggerEventsIfEnabled()},enumerable:!0,configurable:!0}),t.prototype.ngOnInit=function(){this._isInitialized=!0,this._setupTriggerEventsIfEnabled()},t.prototype.ngOnDestroy=function(){this._rippleRenderer._removeTriggerEvents()},t.prototype.fadeOutAll=function(){this._rippleRenderer.fadeOutAll()},Object.defineProperty(t.prototype,"rippleConfig",{get:function(){return{centered:this.centered,radius:this.radius,color:this.color,animation:O({},this._globalOptions.animation,this.animation),terminateOnPointerUp:this._globalOptions.terminateOnPointerUp,speedFactor:this.speedFactor*(this._globalOptions.baseSpeedFactor||1)}},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"rippleDisabled",{get:function(){return this.disabled||!!this._globalOptions.disabled},enumerable:!0,configurable:!0}),t.prototype._setupTriggerEventsIfEnabled=function(){!this.disabled&&this._isInitialized&&this._rippleRenderer.setupTriggerEvents(this.trigger)},t.prototype.launch=function(t,e,n){return void 0===e&&(e=0),"number"==typeof t?this._rippleRenderer.fadeInRipple(t,e,O({},this.rippleConfig,n)):this._rippleRenderer.fadeInRipple(0,0,O({},this.rippleConfig,t))},t.decorators=[{type:e.Directive,args:[{selector:"[mat-ripple], [matRipple]",exportAs:"matRipple",host:{class:"mat-ripple","[class.mat-ripple-unbounded]":"unbounded"}}]}],t.ctorParameters=function(){return[{type:e.ElementRef},{type:e.NgZone},{type:o.Platform},{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[st]}]},{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[s.ANIMATION_MODULE_TYPE]}]}]},t.propDecorators={color:[{type:e.Input,args:["matRippleColor"]}],unbounded:[{type:e.Input,args:["matRippleUnbounded"]}],centered:[{type:e.Input,args:["matRippleCentered"]}],radius:[{type:e.Input,args:["matRippleRadius"]}],speedFactor:[{type:e.Input,args:["matRippleSpeedFactor"]}],animation:[{type:e.Input,args:["matRippleAnimation"]}],disabled:[{type:e.Input,args:["matRippleDisabled"]}],trigger:[{type:e.Input,args:["matRippleTrigger"]}]},t}(),lt=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{imports:[T,o.PlatformModule],exports:[ct,T],declarations:[ct]}]}],t}(),pt=function(){function t(t){this._animationMode=t,this.state="unchecked",this.disabled=!1}return t.decorators=[{type:e.Component,args:[{encapsulation:e.ViewEncapsulation.None,changeDetection:e.ChangeDetectionStrategy.OnPush,selector:"mat-pseudo-checkbox",styles:[".mat-pseudo-checkbox{width:20px;height:20px;border:2px solid;border-radius:2px;cursor:pointer;display:inline-block;vertical-align:middle;box-sizing:border-box;position:relative;flex-shrink:0;transition:border-color 90ms cubic-bezier(0,0,.2,.1),background-color 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox::after{position:absolute;opacity:0;content:'';border-bottom:2px solid currentColor;transition:opacity 90ms cubic-bezier(0,0,.2,.1)}.mat-pseudo-checkbox.mat-pseudo-checkbox-checked,.mat-pseudo-checkbox.mat-pseudo-checkbox-indeterminate{border-color:transparent}._mat-animation-noopable.mat-pseudo-checkbox{transition:none;animation:none}._mat-animation-noopable.mat-pseudo-checkbox::after{transition:none}.mat-pseudo-checkbox-disabled{cursor:default}.mat-pseudo-checkbox-indeterminate::after{top:7px;left:0;width:16px;opacity:1}.mat-pseudo-checkbox-checked::after{top:3px;left:1px;width:12px;height:5px;border-left:2px solid currentColor;transform:rotate(-45deg);opacity:1}"],template:"",host:{class:"mat-pseudo-checkbox","[class.mat-pseudo-checkbox-indeterminate]":'state === "indeterminate"',"[class.mat-pseudo-checkbox-checked]":'state === "checked"',"[class.mat-pseudo-checkbox-disabled]":"disabled","[class._mat-animation-noopable]":'_animationMode === "NoopAnimations"'}}]}],t.ctorParameters=function(){return[{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[s.ANIMATION_MODULE_TYPE]}]}]},t.propDecorators={state:[{type:e.Input}],disabled:[{type:e.Input}]},t}(),ut=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{exports:[pt],declarations:[pt]}]}],t}(),dt=function(){function t(){}return t}(),ht=d(dt),mt=0,ft=function(t){function n(){var e=null!==t&&t.apply(this,arguments)||this;return e._labelId="mat-optgroup-label-"+mt++,e}return p(n,t),n.decorators=[{type:e.Component,args:[{selector:"mat-optgroup",exportAs:"matOptgroup",template:'<label class="mat-optgroup-label" [id]="_labelId">{{ label }}</label><ng-content select="mat-option, ng-container"></ng-content>',encapsulation:e.ViewEncapsulation.None,changeDetection:e.ChangeDetectionStrategy.OnPush,inputs:["disabled"],styles:[".mat-optgroup-label{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup-label[disabled]{cursor:default}[dir=rtl] .mat-optgroup-label{text-align:right}.mat-optgroup-label .mat-icon{margin-right:16px;vertical-align:middle}.mat-optgroup-label .mat-icon svg{vertical-align:top}[dir=rtl] .mat-optgroup-label .mat-icon{margin-left:16px;margin-right:0}"],host:{class:"mat-optgroup",role:"group","[class.mat-optgroup-disabled]":"disabled","[attr.aria-disabled]":"disabled.toString()","[attr.aria-labelledby]":"_labelId"}}]}],n.propDecorators={label:[{type:e.Input}]},n}(ht),gt=0,_t=function(){function t(t,e){void 0===e&&(e=!1),this.source=t,this.isUserInput=e}return t}(),yt=new e.InjectionToken("MAT_OPTION_PARENT_COMPONENT"),bt=function(){function t(t,n,i,o){this._element=t,this._changeDetectorRef=n,this._parent=i,this.group=o,this._selected=!1,this._active=!1,this._disabled=!1,this._id="mat-option-"+gt++,this._mostRecentViewValue="",this.onSelectionChange=new e.EventEmitter,this._stateChanges=new r.Subject}return Object.defineProperty(t.prototype,"multiple",{get:function(){return this._parent&&this._parent.multiple},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return this._id},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"selected",{get:function(){return this._selected},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"disabled",{get:function(){return this.group&&this.group.disabled||this._disabled},set:function(t){this._disabled=i.coerceBooleanProperty(t)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"disableRipple",{get:function(){return this._parent&&this._parent.disableRipple},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"active",{get:function(){return this._active},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"viewValue",{get:function(){return(this._getHostElement().textContent||"").trim()},enumerable:!0,configurable:!0}),t.prototype.select=function(){this._selected||(this._selected=!0,this._changeDetectorRef.markForCheck(),this._emitSelectionChangeEvent())},t.prototype.deselect=function(){this._selected&&(this._selected=!1,this._changeDetectorRef.markForCheck(),this._emitSelectionChangeEvent())},t.prototype.focus=function(){var t=this._getHostElement();"function"==typeof t.focus&&t.focus()},t.prototype.setActiveStyles=function(){this._active||(this._active=!0,this._changeDetectorRef.markForCheck())},t.prototype.setInactiveStyles=function(){this._active&&(this._active=!1,this._changeDetectorRef.markForCheck())},t.prototype.getLabel=function(){return this.viewValue},t.prototype._handleKeydown=function(t){t.keyCode!==c.ENTER&&t.keyCode!==c.SPACE||(this._selectViaInteraction(),t.preventDefault())},t.prototype._selectViaInteraction=function(){this.disabled||(this._selected=!this.multiple||!this._selected,this._changeDetectorRef.markForCheck(),this._emitSelectionChangeEvent(!0))},t.prototype._getTabIndex=function(){return this.disabled?"-1":"0"},t.prototype._getHostElement=function(){return this._element.nativeElement},t.prototype.ngAfterViewChecked=function(){if(this._selected){var t=this.viewValue;t!==this._mostRecentViewValue&&(this._mostRecentViewValue=t,this._stateChanges.next())}},t.prototype.ngOnDestroy=function(){this._stateChanges.complete()},t.prototype._emitSelectionChangeEvent=function(t){void 0===t&&(t=!1),this.onSelectionChange.emit(new _t(this,t))},t.decorators=[{type:e.Component,args:[{selector:"mat-option",exportAs:"matOption",host:{role:"option","[attr.tabindex]":"_getTabIndex()","[class.mat-selected]":"selected","[class.mat-option-multiple]":"multiple","[class.mat-active]":"active","[id]":"id","[attr.aria-selected]":"selected.toString()","[attr.aria-disabled]":"disabled.toString()","[class.mat-option-disabled]":"disabled","(click)":"_selectViaInteraction()","(keydown)":"_handleKeydown($event)",class:"mat-option"},styles:[".mat-option{white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:block;line-height:48px;height:48px;padding:0 16px;text-align:left;text-decoration:none;max-width:100%;position:relative;cursor:pointer;outline:0;display:flex;flex-direction:row;max-width:100%;box-sizing:border-box;align-items:center;-webkit-tap-highlight-color:transparent}.mat-option[disabled]{cursor:default}[dir=rtl] .mat-option{text-align:right}.mat-option .mat-icon{margin-right:16px;vertical-align:middle}.mat-option .mat-icon svg{vertical-align:top}[dir=rtl] .mat-option .mat-icon{margin-left:16px;margin-right:0}.mat-option[aria-disabled=true]{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;cursor:default}.mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:32px}[dir=rtl] .mat-optgroup .mat-option:not(.mat-option-multiple){padding-left:16px;padding-right:32px}@media screen and (-ms-high-contrast:active){.mat-option{margin:0 1px}.mat-option.mat-active{border:solid 1px currentColor;margin:0}}.mat-option-text{display:inline-block;flex-grow:1;overflow:hidden;text-overflow:ellipsis}.mat-option .mat-option-ripple{top:0;left:0;right:0;bottom:0;position:absolute;pointer-events:none}@media screen and (-ms-high-contrast:active){.mat-option .mat-option-ripple{opacity:.5}}.mat-option-pseudo-checkbox{margin-right:8px}[dir=rtl] .mat-option-pseudo-checkbox{margin-left:8px;margin-right:0}"],template:'<mat-pseudo-checkbox *ngIf="multiple" class="mat-option-pseudo-checkbox" [state]="selected ? \'checked\' : \'\'" [disabled]="disabled"></mat-pseudo-checkbox><span class="mat-option-text"><ng-content></ng-content></span><div class="mat-option-ripple" mat-ripple [matRippleTrigger]="_getHostElement()" [matRippleDisabled]="disabled || disableRipple"></div>',encapsulation:e.ViewEncapsulation.None,changeDetection:e.ChangeDetectionStrategy.OnPush}]}],t.ctorParameters=function(){return[{type:e.ElementRef},{type:e.ChangeDetectorRef},{type:void 0,decorators:[{type:e.Optional},{type:e.Inject,args:[yt]}]},{type:ft,decorators:[{type:e.Optional}]}]},t.propDecorators={value:[{type:e.Input}],disabled:[{type:e.Input}],onSelectionChange:[{type:e.Output}]},t}(),vt=function(){function t(){}return t.decorators=[{type:e.NgModule,args:[{imports:[lt,l.CommonModule,ut],exports:[bt,ft],declarations:[bt,ft]}]}],t}(),Dt=new e.InjectionToken("mat-label-global-options");t.AnimationCurves=C,t.AnimationDurations=x,t.MatCommonModule=T,t.MATERIAL_SANITY_CHECKS=M,t.mixinDisabled=d,t.mixinColor=h,t.mixinDisableRipple=m,t.mixinTabIndex=f,t.mixinErrorState=g,t.mixinInitialized=_,t.NativeDateModule=U,t.MatNativeDateModule=G,t.MAT_DATE_LOCALE=k,t.MAT_DATE_LOCALE_FACTORY=y,t.MAT_DATE_LOCALE_PROVIDER=R,t.DateAdapter=A,t.MAT_DATE_FORMATS=S,t.NativeDateAdapter=z,t.MAT_NATIVE_DATE_FORMATS=Y,t.ShowOnDirtyErrorStateMatcher=B,t.ErrorStateMatcher=W,t.MAT_HAMMER_OPTIONS=J,t.GestureConfig=$,t.MatLine=Q,t.MatLineSetter=tt,t.MatLineModule=et,t.MatOptionModule=vt,t.MatOptionSelectionChange=_t,t.MAT_OPTION_PARENT_COMPONENT=yt,t.MatOption=bt,t._countGroupLabelsBeforeOption=E,t._getOptionScrollPosition=I,t.MatOptgroupBase=dt,t._MatOptgroupMixinBase=ht,t.MatOptgroup=ft,t.MAT_LABEL_GLOBAL_OPTIONS=Dt,t.MatRippleModule=lt,t.MAT_RIPPLE_GLOBAL_OPTIONS=st,t.MatRipple=ct,t.RippleState=nt,t.RippleRef=it,t.defaultRippleAnimationConfig=rt,t.RippleRenderer=at,t.MatPseudoCheckboxModule=ut,t.MatPseudoCheckbox=pt,t.JAN=0,t.FEB=1,t.MAR=2,
t.APR=3,t.MAY=4,t.JUN=5,t.JUL=6,t.AUG=7,t.SEP=8,t.OCT=9,t.NOV=10,t.DEC=11,t.ɵa1=u,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=material-core.umd.min.js.map
